function GsubA(task)
%task=1:140
load GDP;
D = GDP(1:(79+task),:); 

indx = 1;
    for i=2:2:98
        for j=i:2:98
            pi = i/100;
            qi = j/100;
            if (pi+qi)>=(1+eps)
                PQ(indx,1) = pi;
                PQ(indx,2) = qi;
                indx = indx+1;
            end
        end
    end
    %clear; close all; clc
 
%% trimming parameters and number of simulation replications
    trm=0.02;
    nrep=5000;
    
%%  Preparation
    
    y = D(:,1);
    T = size(y,1);
    x = ones(T,2);
    x(:,2) = D(:,2);    
    
    lp = trm;
    up = 1-trm;
    lq = trm;
    uq = 1-trm;
    L=trm;%0.05;0.02;
    U=1-2*trm;%0.90;0.96;
    tol=1e-5; %tol for zero; 
    rng(123456*task);%set seed for replicability
    
    %parpool (10);
    tic
%% The SupLR test

    %estimation under H_0
    [est0, loglik0] = lik_null(y,x);
    
    % estimation under H_1; use multiple initial values
    %mx=-1e6;
    tlr=zeros(16,1);
    estr=zeros(16,6);
    for ct = 1:16
        [est11, loglik1] = lik_pqfixe(y,x,lp,up,lq,uq,trm);
        tlr(ct) = 2*(loglik1-loglik0);
        estr(ct,:)=est11;
    end
    [mx,ind]=max(tlr);
    %est1=estr(ind,:);
   
    %critical values for the SupLR test   
    
    count = size(PQ,1);
    V = re(y, x,est0, PQ);
    [A,S,~] = svd(V);
    slr=zeros(nrep-1,1);
    
    for simu=1:(nrep-1)
        u = randn(3*count,1);
        L234 = (A*sqrt(S)*u);
        [lr,~] = opt(L234,V);
        slr(simu)=lr;
    end
    
   
    slr=sort(slr);
    cvs=[slr(ceil(nrep*0.90)),slr(ceil(nrep*0.925)),slr(ceil(nrep*0.95))];
    
    SupLR_result=[cvs(1),cvs(3),mx];
 %% The SupTS test of CHP
 
    [test,~] = funcTSm(y,x,L,U,tol);
    b0 = regress(y,x);
    u  = y-x*b0; 
    v0 = std(u,1);
    estc = [b0;v0];
    cvc=cvchp(y,estc,L, U, nrep, tol);
                                                        
    SupTS_result=[cvc(1),cvc(3),test];
    
  %% The QLR test of CW 
    lp=0;
    up=1;
    lr=zeros(16,1);
    for ct = 1:16  %optimization with different initial values
           [~, lik_a] = lik_pqcwe(y,x,lp,up);
           lr(ct) = 2*(lik_a-loglik0);
           
           
    end
    cw=max(lr);
    QLR_result=cw;
    toc
    All_result=[SupLR_result,QLR_result,SupTS_result];
    
    myfile =[ 'GDPS', num2str(task) '.mat'];
    disp(All_result);
    
    save (myfile,'All_result');
    %delete(gcp('nocreate'));  
end
