library(R.matlab)


data<-readMat("GDPS.mat") 

rt<-data$LR

windows()

plot.new()
par(omi=c(0.0,0.0,0.8,0.0))
#title("Figure 2: Test statistic values over subsamples",outer=TRUE)
par(mfcol=c(2, 2))


par(mfg=c(1, 1, 2, 2))
par(mai=c(0.4, 0.4, 0.4, 0.4))



xx=seq(1,140,by=1)
zz=rt[,3]
plot(xx,zz,type='l',axes=FALSE, xlab="Horizon",ylab="Percent",ylim=c(4,12))
lines(rt[,2],lwd=1.5,lty=3)
axis(1,at=c(1,21,41,61,81,101,121,141), lab=c(1980,1985,1990,1995,2000,2005,2010,2015))

axis(2)
box()
mtext("\n(a) SupLR", outer=FALSE,adj=0.5,cex=0.8,line=1)

#---------------------------------------------------------------------
par(mai=c(0.4, 0.4, 0.4, 0.4))
par(mfg=c(1, 2, 2, 2))
#par(mai=c(0.3, 1.7, 1.1, 1.5))
zz=rt[,4]
zw=rep(1,140)*5.61;
plot(xx,zz,type='l',,axes=FALSE, xlab="quantile index",ylab="value",ylim=c(0,7))

#lines(rt[21:40,2],col='1',lwd=1.5,lty=2)
lines(zw,lwd=1.5,lty=3)
axis(1,at=c(1,21,41,61,81,101,121,141), lab=c(1980,1985,1990,1995,2000,2005,2010,2015))

axis(2)
box()

mtext("\n(b) QLR", outer=FALSE,adj=0.5,cex=0.8,line=1)



#---------------------------------------------------------------------
par(mai=c(0.4, 0.4, 0.4, 0.4))
par(mfg=c(2, 1, 2, 2))
#par(mai=c(0.3, 1.7, 1.1, 1.5))
zz=rt[,7]

plot(xx,zz,type='l',axes=FALSE,xlab="quantile index",ylab="value",ylim=c(0,4))

lines(rt[,6],lwd=1.5,lty=3)
axis(1,at=c(1,21,41,61,81,101,121,141), lab=c(1980,1985,1990,1995,2000,2005,2010,2015))

axis(2)
box()

mtext("\n(c) supTS", outer=FALSE,adj=0.5,cex=0.8,line=1)


