clear; close all; clc;

%% load data
load GDP;
D=GDP;%full sample
%D=GDP(1:187,:);% till 2006

%% set up model
y = D(:,1);
T = size(y,1);
x = ones(T,2);
x(:,2) = D(:,2); 
mx = -1e6;
trm=0.02;
lp = 0.02;
up = 0.98;
lq = 0.02;
uq = 0.98;
        
%% estimate the parameters
%estimation under H_0
[est0, loglik0] = lik_null(y,x);
    
tlr=zeros(16,1);
estr=zeros(16,6);
for ct = 1:16
        [est11, loglik1] = lik_pqfixe(y,x,lp,up,lq,uq,trm);
        tlr(ct) = 2*(loglik1-loglik0);
        estr(ct,:)=est11;
end
[mx,ind]=max(tlr);
est1=estr(ind,:);

%% computed the smoothed recession probability

pms    = est1;
beta11 = pms(1);
beta12 = pms(2);
beta2  = pms(3);
sigma2 = pms(4);
p      = pms(5);
q      = pms(6);
n = length(y);
nln = 0;
PRL = zeros(n,1);
PR = zeros(n,1);

for i=1:T
    if i==1
        PR(i) = (1-q)/(2-p-q);
    else
        PR(i) = p*PRL(i-1)+(1-q)*(1-PRL(i-1));
    end
    PRL(i) = (exp(-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*PR(i))/(exp(-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*PR(i)+exp(-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*(1-PR(i)));
    nln = nln-log(PR(i)*(2*pi*sigma2)^(-0.5)*exp((-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2)/(2*sigma2))+(1-PR(i))*(2*pi*sigma2)^(-0.5)*exp((-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2)/(2*sigma2)));
end

SPR = zeros(T,1);
SPR(T,1) = PRL(T,1);
for i=1:T-1
    SPR(T-i) = PRL(T-i)*(p*SPR(T-i+1)/PR(T-i+1)+(1-p)*(1-SPR(T-i+1))/(1-PR(T-i+1)));
end

SPR=SPR.*(SPR<=1)+1.*(SPR>1);

figure    
plot(SPR);

save prob SPR;