clear; clc; close all;

%Case 2: strictly exogeneous regressor, swtiching reg coef, unknown variance
%Case 3: AR(1), swtiching reg coef, unknown variance
%Case 4: switching variance, unknown coef 
%Case 5: same as case 2, except the variance is known
%Case 6: same as case 3, except the variance is known

cases=6; %default. Change to other cases to obtain corresponding results
%You also need to change the output file on line 57 accordingly

d  = 0.5; 
ss = 1; %variance
T  = 250;
pStart = 0.60;
pEnd = 0.60;
pInv = 0.02;
qStart = 0.10;
qEnd = 0.90;
qInv = 0.02;
pnp = size((pStart:pInv:pEnd),2); %probability p grid
qnp = size((qStart:qInv:qEnd),2); %probability q grid
count = pnp*qnp; %the number of possible (p,q) combinations

PQ = zeros(count,2); %all possible (p,q) combinations 
for i=1:count 
    PQ(i,1) = (floor((i-1)/qnp))*pInv+pStart;
    PQ(i,2) = (rem((i-1),qnp))*qInv+qStart;
   
end

%matlabpool open local
iter = 20000;
covM = zeros(41,iter);
YY=zeros(1,iter);
parfor ci = 1:iter
    if cases==2 | cases==5
    model='CG';
    elseif cases==3 | cases==4 | cases==6
    model='CA';
    else
    display ('error');
    end
    [y,x] = RS_dgpS1( d, ss, T,model); %change with cases
    AY = re0(y, x, PQ,ss,cases); %change with cases
    covM(:,ci) = AY;
    ci
     YY(ci) = re0(y, x, [0.6,0.9],ss,cases); %change with cases
end

c = zeros(41,1);
parfor i=1:41
    cr = corrcoef(YY,covM(i,:));
    c(i) = cr(1,2); 
end

save case6_ecor
%matlabpool close
