%Case 2: strictly exogeneous regressor, swtiching reg coef, unknown variance
%Case 3: AR(1), swtiching reg coef, unknown variance
%Case 4: switching variance, unknown coef 
%Case 5: same as case 2, except the variance is known
%Case 6: same as case 3, except the variance is known


clear;clc;close all;

kernel = 6; %choose the case. 
%You can change to other values between 2 and 5. Also change the output
%file on line 104 accordingly

d = 0.5;
pStart = 0.60;
pEnd = 0.60;
pInv = 0.02;
qStart = 0.10;
qEnd = 0.90;
qInv = 0.02;
pnp = size((pStart:pInv:pEnd),2); %probability p grid
qnp = size((qStart:qInv:qEnd),2); %probability q grid
count = pnp*qnp; %the number of possible (p,q) combinations

PQ = zeros(count,2); %all possible (p,q) combinations 
for i=1:count 
    PQ(i,1) = (floor((i-1)/qnp))*pInv+pStart;
    PQ(i,2) = (rem((i-1),qnp))*qInv+qStart;
   
end
rho = sum(PQ,2)-1; 
xi  = (1-PQ(:,2))./(2-sum(PQ,2));

%The following is needed for the strictly exogeneous regressor case
vw=1; %varaiance
dw=0.5;%ar-1 coef
Ew2=vw/(1-dw^2);
Ew4=3*vw^2/(1-dw^2)^2;
Vw2=2*vw^2/(1-dw^2)^2;

xi=[0.2;xi]; %the first point corresponds to (0.6,0.9)
rho=[0.5;rho]; %the first point corresponds to (0.6,0.9)

switch kernel
    %constant wt
    case 1; k = @(ni,nj) ((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*4*rho(ni)*rho(nj)/(1-rho(ni)*rho(nj));
    %strictly exogeneous regressor, swtiching reg coef, unknown variance
 
    %case 2; k = @(ni,nj) 2*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*2 ...
           %             +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*(1-rho(ni)*rho(nj))^-1*1;  
    case 2; k = @(ni,nj) 2*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*Vw2 ...
                        +4*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*rho(ni)*rho(nj)*Ew4*dw^2/(1-rho(ni)*rho(nj)*dw^2) ...
                        +4*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*rho(ni)*rho(nj)*vw*Ew2/((1-dw^2)*(1-rho(ni)*rho(nj))) ...
                        -4*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*rho(ni)*rho(nj)*vw*Ew2*dw^2/((1-dw^2)*(1-rho(ni)*rho(nj)*dw^2)); 
    %iid AR(1), swtiching reg coef, unknown variance 
    case 3; k = @(ni,nj) 4*((1-d^2)^-2)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        *((1-d^2)^-2)*(2*(1-rho(ni)*rho(nj)*d^2)^-1+(1-rho(ni)*rho(nj))^-1) ...
                        +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        *((1-d^2)^-1)*(4*rho(ni)*d^2*(1-rho(ni)*d^2)^-1*(1-rho(ni)*rho(nj)*d^2)^-1) ...
                        +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        *((1-d^2)^-1)*(4*rho(nj)*d^2*(1-rho(nj)*d^2)^-1*(1-rho(ni)*rho(nj)*d^2)^-1) ...
                        -16*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*(d^2/(1-d^2)) ...
                        *((1-rho(ni)*d^2)^-1)*((1-rho(nj)*d^2)^-1);
    %switching variance, unknown coef                
    case 4; k = @(ni,nj) ((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*(1.5+rho(ni)*rho(nj)/(1-rho(ni)*rho(nj)));
    %same as case 2, variance known
     % case 5; k = @(ni,nj) 2*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*3 ...
         %               +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*(1-rho(ni)*rho(nj))^-1*1;
     case 5; k = @(ni,nj) 2*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*Ew4 ...
                        +4*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*rho(ni)*rho(nj)*Ew4*dw^2/(1-rho(ni)*rho(nj)*dw^2) ...
                        +4*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*rho(ni)*rho(nj)*vw*Ew2/((1-dw^2)*(1-rho(ni)*rho(nj))) ...
                        -4*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*rho(ni)*rho(nj)*vw*Ew2*dw^2/((1-dw^2)*(1-rho(ni)*rho(nj)*dw^2)); 
      
         
    %same as case 3, known variance                
    case 6; k = @(ni,nj) 6*((1-d^2)^-2)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        *((1-d^2)^-2)*(2*(1-rho(ni)*rho(nj)*d^2)^-1+(1-rho(ni)*rho(nj))^-1) ...
                        +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        *((1-d^2)^-1)*(4*rho(ni)*d^2*(1-rho(ni)*d^2)^-1*(1-rho(ni)*rho(nj)*d^2)^-1) ...
                        +4*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj)) ...
                        *((1-d^2)^-1)*(4*rho(nj)*d^2*(1-rho(nj)*d^2)^-1*(1-rho(ni)*rho(nj)*d^2)^-1)...
                        -16*rho(ni)*rho(nj)*((1-xi(ni))/xi(ni))*((1-xi(nj))/xi(nj))*(d^2/(1-d^2)) ...
                        *((1-rho(ni)*d^2)^-1)*((1-rho(nj)*d^2)^-1);                 

end 

%choose points

n = length(rho);

%construct the covariance matrix
C = zeros(n,n);
for ni=1:n
    for nj=1:n
        C(ni,nj) = k(ni,nj);
    end
end
c1 = (sqrt(diag(C))).^-1;
c  = C.*(c1*c1');  % to get the correlation function.
c=c(2:42,1:42); %remove the first row, will use the rest of the first column

save case6_cor



