

require(R.matlab)

#Include the data files in Table_1 folder in the same directory when running this code

#load data. four cases in total. The default is Case 1 (T=1000). 
#Comment out this case to run other cases.

#case 1; T=1000 for the static and dynamic models
data.s <- readMat('power_q0.2_c7.3_s_1000.mat')
data0.s <- readMat('power_q0.2_c0_s_1000.mat')

data.d <- readMat('power_q0.2_c7.3_d_1000.mat')
data0.d <- readMat('power_q0.2_c0_d_1000.mat')

#case 2; T=5000 for the static and dynamic models
#data.s <- readMat('power_q0.2_c7.3_s_5000.mat')
#data0.s <- readMat('power_q0.2_c0_s_5000.mat')
#data.d <- readMat('power_q0.2_c7.3_d_5000.mat')
#data0.d <- readMat('power_q0.2_c0_d_5000.mat')


#case 3; T=20000 for the static and dynamic models
#data.s <- readMat('power_q0.2_c7.3_s_20000.mat')
#data0.s <- readMat('power_q0.2_c0_s_20000.mat')
#data.d <- readMat('power_q0.2_c7.3_d_20000.mat')
#data0.d <- readMat('power_q0.2_c0_d_20000.mat')

#case 4; T=50000 for the static and dynamic models

#data.s <- readMat('power_q0.2_c7.3_s_50000.mat')
#data0.s <- readMat('power_q0.2_c0_s_50000.mat')

#data.d <- readMat('power_q0.2_c7.3_d_50000.mat')
#data0.d <- readMat('power_q0.2_c0_d_50000.mat')


#columns of saved data: (1) CHP approximation, (2) CHP finite sample, (3)LR app, (4) LR
#sample, (5)CW app, (6) CW sample
chpa1.s<-data.s$z[,1]
chpf1.s<-data.s$z[,2]

lra1.s<-data.s$z[,3]
lrf1.s<-data.s$z[,4]

chpa1.d<-data.d$z[,1]
chpf1.d<-data.d$z[,2]

lra1.d<-data.d$z[,3]
lrf1.d<-data.d$z[,4]


#columns of saved data: (1) CHP approximation, (2) CHP finite sample, (3)LR app, (4) LR
#sample, (5)CW app, (6) CW sample
chpa0.s<-data0.s$z[,1]
chpf0.s<-data0.s$z[,2]

lra0.s<-data0.s$z[,3]
lrf0.s<-data0.s$z[,4]

chpa0.d<-data0.d$z[,1]
chpf0.d<-data0.d$z[,2]

lra0.d<-data0.d$z[,3]
lrf0.d<-data0.d$z[,4]


#dev.new()
windows()

plot.new()
par(omi=c(0.0,0.0,0.8,0.0))

title(bquote(atop("Figure S18. The refined approximations and their finite sample counterparts: " ~ T~ "=1000")),outer=TRUE)

par(mfcol=c(2, 2))


par(mfg=c(1, 1, 2, 2))
par(mai=c(0.7, 0.7, 0.7, 0.7))



plot(ecdf(lrf0.s), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(lra0.s),ppoints(lrf0.s),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(lra1.s),ppoints(lra1.s),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(lrf1.s),ppoints(lrf1.s),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(a1) LR: static model", outer=FALSE,adj=0.5,cex=0.8,line=1)

par(mfg=c(1, 2, 2, 2))
par(mai=c(0.7, 0.7, 0.7, 0.7))



plot(ecdf(chpf0.s), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(chpa0.s),ppoints(chpf0.s),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(chpa1.s),ppoints(chpa1.s),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(chpf1.s),ppoints(chpf1.s),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(a2) TS: static model", outer=FALSE,adj=0.5,cex=0.8,line=1)


par(mfg=c(2, 1, 2, 2))
par(mai=c(0.7, 0.7, 0.7, 0.7))



plot(ecdf(lrf0.d), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(lra0.d),ppoints(lrf0.d),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(lra1.d),ppoints(lra1.d),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(lrf1.d),ppoints(lrf1.d),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(b1) LR: dynamic model", outer=FALSE,adj=0.5,cex=0.8,line=1)

par(mfg=c(2, 2, 2, 2))
par(mai=c(0.7, 0.7, 0.7, 0.7))



plot(ecdf(chpf0.d), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(chpa0.d),ppoints(chpf0.d),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(chpa1.d),ppoints(chpa1.d),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(chpf1.d),ppoints(chpf1.d),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(b2) TS: dynamic model", outer=FALSE,adj=0.5,cex=0.8,line=1)

