require(R.matlab)

#load data. Sixteen cases in total. The default is Case 1 (Static model, q=0.2). 
#Comment out this case to run other cases.
#Include the data files in Table_1 folder in the same directory when running this code.

data <- readMat('power_q0.2_c7.3_s.mat')
data0 <- readMat('power_q0.2_c0_s.mat')

#data <- readMat('power_q0.4_c6.4_s.mat')
#data0 <- readMat('power_q0.4_c0_s.mat')

#data <- readMat('power_q0.6_c4.7_s.mat')
#data0 <- readMat('power_q0.6_c0_s.mat')

#data <- readMat('power_q0.8_c3_s.mat')
#data0 <- readMat('power_q0.8_c0_s.mat')

#data <- readMat('power_q0.2_c7.3_d.mat')
#data0 <- readMat('power_q0.2_c0_d.mat')

#data <- readMat('power_q0.4_c6.4_d.mat')
#data0 <- readMat('power_q0.4_c0_d.mat')

#data <- readMat('power_q0.6_c4.7_d.mat')
#data0 <- readMat('power_q0.6_c0_d.mat')

#data <- readMat('power_q0.8_c3_d.mat')
#data0 <- readMat('power_q0.8_c0_d.mat')

#data <- readMat('power_q0.2_c7.3_s_1000.mat')
#data0 <- readMat('power_q0.2_c0_s_1000.mat')

#data <- readMat('power_q0.4_c6.4_s_1000.mat')
#data0 <- readMat('power_q0.4_c0_s_1000.mat')

#data <- readMat('power_q0.6_c4.7_s_1000.mat')
#data0 <- readMat('power_q0.6_c0_s_1000.mat')

#data <- readMat('power_q0.8_c3_s_1000.mat')
#data0 <- readMat('power_q0.8_c0_s_1000.mat')

#data <- readMat('power_q0.2_c7.3_d_1000.mat')
#data0 <- readMat('power_q0.2_c0_d_1000.mat')

#data <- readMat('power_q0.4_c6.4_d_1000.mat')
#data0 <- readMat('power_q0.4_c0_d_1000.mat')

#data <- readMat('power_q0.6_c4.7_d_1000.mat')
#data0 <- readMat('power_q0.6_c0_d_1000.mat')

#data <- readMat('power_q0.8_c3_d_1000.mat')
#data0 <- readMat('power_q0.8_c0_d_1000.mat')


#columns of saved data: (1) CHP approximation, (2) CHP finite sample, (3)LR app, (4) LR
#sample, (5)CW app, (6) CW sample
chpa1<-data$z[,1]
chpf1<-data$z[,2]

lra1<-data$z[,3]
lrf1<-data$z[,4]

qlra1<-data$z[,5]
qlrf1<-data$z[,6]



#columns of saved data: (1) CHP approximation, (2) CHP finite sample, (3)LR app, (4) LR
#sample, (5)CW app, (6) CW sample
chpa0<-data0$z[,1]
chpf0<-data0$z[,2]

lra0<-data0$z[,3]
lrf0<-data0$z[,4]

qlra0<-data0$z[,5]
qlrf0<-data0$z[,6]

#dev.new()
windows()

plot.new()
par(omi=c(0.0,0.0,0.8,0.0))

title(bquote(atop("Figure S2. Distributions under a simple DGP: static model," ~ q["*"]~ "=0.2")),outer=TRUE)
#title(bquote(atop("Figure S17. Distributions under a simple DGP: dynamic model," ~ q["*"]~ "=0.8,"~ T~ "=1000")),outer=TRUE)

par(mfcol=c(3, 1))


par(mfg=c(1, 1, 3, 1))
par(mai=c(0.4, 1.5, 0.4, 1.5))



plot(ecdf(lrf0), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(lra0),ppoints(lrf0),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(lra1),ppoints(lra1),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(lrf1),ppoints(lrf1),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(a) LR", outer=FALSE,adj=0.5,cex=0.8,line=1)

par(mfg=c(2, 1, 3, 1))
par(mai=c(0.4, 1.5, 0.4, 1.5))



plot(ecdf(qlrf0), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(qlra0),ppoints(qlrf0),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(qlra1),ppoints(qlra1),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(qlrf1),ppoints(qlrf1),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(b) QLR", outer=FALSE,adj=0.5,cex=0.8,line=1)


par(mfg=c(3, 1, 3, 1))
par(mai=c(0.4, 1.5, 0.4, 1.5))



plot(ecdf(chpf0), verticals=TRUE, do.points=FALSE,lty=1,col='red',xlim=c(0,30),xlab="",ylab="",main=NULL)
lines(sort(chpa0),ppoints(chpf0),type="l",lty="dotted",ylim=c(0,1),col='red') 
lines(sort(chpa1),ppoints(chpa1),type="l",lty="dotted",ylim=c(0,1),col='black') 
lines(sort(chpf1),ppoints(chpf1),type="l",lty=1,ylim=c(0,1)) 
mtext("\n(c) TS", outer=FALSE,adj=0.5,cex=0.8,line=1)

