clear; clc; close all;

tic
b1 = 0;   %constant term
b2 = 0.5;   %AR(1) coefficient
s2 = 1;     %variance of e_t
T  = 250; %sample size
iter = 5000;

LR1 = zeros(iter,1); % save the bootstrap distribution
[y,x]= RS_dgp( b1, b2, s2, T, 'CA');%DGP
[est0, lik_0] = lik_null(y,x);%estimation under the null
bn   = length(est0);
bHat = est0(1,1:bn-1)';
ess  = est0(bn); 

indx = 1;
for i=55:5:95
    for j=i:5:95
        pi = i/100;
        qi = j/100;
        if (pi+qi)>=(1+eps)
            PQ(indx,1) = pi;
            PQ(indx,2) = qi;
            indx = indx+1;
        end
    end
end

%parpool(16);
 
%matlabpool open local
parfor ss=1:iter
    % Bootstrapping: y_t=b1+b2*y_t-1+e_t, x is fixed
    y= RS_dgp_boots(bHat(1),bHat(2),ess,T,x);
    [~, lik_0] = lik_null(y,x);
    LR1(ss) = lik_pqvar(y,x,PQ,lik_0);
    [ss,LR1(ss)]
 end
save fixboots_e

%plot Figure 3
h=figure;
hold on;
load('mu5595');%This is produced by the code in Figure_2 folder
[f,xi] = ecdf(LRt);
plot(xi,f,'-k','LineWidth',1.5);

hold on;
load('fixboots_e');%bootstrap distribution
[f,xi] = ecdf(LR1);
plot(xi,f,'--k','LineWidth',1.5);


axis([0 10 0 1]);
set(h,'Position',[100 100 800 600]);
legend('Finite Sample','Bootstrap','location','southeast');


axis([0 15 0 1]);
set(h,'Position',[100 100 800 600]);
hold off

cvs=sort(LR1);
cv90=cvs(length(cvs)*0.90);
cv95=cvs(length(cvs)*0.95);
rejf90=mean(LRt>cv90);
rejf95=mean(LRt>cv95);

disp ("rejection rate at the 10% level");
disp (rejf90);

disp ("rejection rate at the 5% level");
disp(rejf95);

toc

