clear; close all; clc

%Choose the application: 
%1.hours worked, 
%2.utilization,
%3.consumption,
%4.umemployment.
series=3;

%You should not need to modify the code below

%% load data
    data=xlsread('data.xlsx');
    z=load('nber_long.txt');
    begt=1;
    if series==2
        begt=30;
    end
    D=data(begt:length(data),series);     
    n=length(D);
    y = D(2:n);
    x = ones(n-1,1);
    x(:,2) = D(1:n-1); 
    T=length(y);
    z=z(length(z)-T+1:length(z));
    
    %D=GDP(1:187,:);% till 2006
    %x=x(1:187,:);
    %y=y(1:187);
    
    
 
%% trimming parameter
    trm=0.02;
   
    
%%  Preparation
    lp = trm;
    up = 1-trm;
    lq = trm;
    uq = 1-trm;
    tic
%% Estimate the model parameters
    %b0 = regress(y,x);
    %u  = y-x*b0; 
    %v0 = std(u,1);
    adj=std(y);
    y=y/adj;
    x(:,2)=x(:,2)/adj;
    %estimation under H_0
    [est0, loglik0] = lik_null(y,x);
   
    % estimation under H_1; use multiple initial values
    %mx=-1e6;
    tlr=zeros(16,1);
    estr=zeros(16,6);
    for ct = 1:16
        [est11, loglik1] = lik_pqfixe(y,x,lp,up,lq,uq,trm);
        tlr(ct) = 2*(loglik1-loglik0);
        estr(ct,:)=est11;
    end
    [mx,ind]=max(tlr);
    est1=estr(ind,:);
   
pms    = est1;
beta11 = pms(1);
beta12 = pms(2);
beta2  = pms(3);
sigma2 = pms(4);
p      = pms(5);
q      = pms(6);
n = length(y);
nln = 0;
PRL = zeros(n,1);
PR = zeros(n,1);
%compute the smoothed recession probabilities
for i=1:T
    if i==1
        PR(i) = (1-q)/(2-p-q);
    else
        PR(i) = p*PRL(i-1)+(1-q)*(1-PRL(i-1));
    end
    PRL(i) = (exp(-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*PR(i))/(exp(-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*PR(i)+exp(-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*(1-PR(i)));
    nln = nln-log(PR(i)*(2*pi*sigma2)^(-0.5)*exp((-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2)/(2*sigma2))+(1-PR(i))*(2*pi*sigma2)^(-0.5)*exp((-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2)/(2*sigma2)));
end

SPR = zeros(T,1);
SPR(T,1) = PRL(T,1);
for i=1:T-1
    SPR(T-i) = PRL(T-i)*(p*SPR(T-i+1)/PR(T-i+1)+(1-p)*(1-SPR(T-i+1))/(1-PR(T-i+1)));
end

SPR=SPR.*(SPR<=1)+1.*(SPR>1);

if series==4
    SPR=1-SPR;
end;

myfile = ['SPR' num2str(series) '.mat'];
save (myfile,'SPR');

figure    
plot(SPR);
hold on;

%save prob SPR;
%z=load('nber_long.txt');
plot(z);
hold off;

