library(R.matlab)


prob1<-readMat("SPR1.mat")$SPR 
prob2<-readMat("SPR2.mat")$SPR 
prob3<-readMat("SPR3.mat")$SPR 
prob4<-readMat("SPR4.mat")$SPR 


nber_long<-scan("nber_long.txt")


windows()

plot.new()
par(omi=c(0.0,0.0,0.2,0.0))
#
par(mfcol=c(2, 1))


par(mfg=c(1, 1, 2, 1))
par(mai=c(0.6, 0.7,1, 0.6))

xz=seq(1,219,by=1)
xx=c(xz,rev(xz))
lowb=rep(0,219)
zz=c(lowb,rev(nber_long))
plot(xx,zz,type='n',axes=FALSE,xlab="Horizon",ylab="",ylim=c(0,1),main="Figure S23: Recession probabilities based on hours worked \n (1960-2014)")
polygon(xx,zz, col="grey",border=NA,xlab="Horizon",ylab="")

xx=seq(1,219,by=1)
lines(xx,prob1,type='l', xlab="Horizon",ylab="Percent",ylim=c(0,1))

axis(1,at=c(0,20,40,60,80,100,120,140,160,180,200,220), lab=c(1960,1965,1970,1975,1980,1985,1990,1995,2000,2005,2010,2015))


axis(2)
box()
#---------------------------------------------------------------------

par(mfg=c(2, 1, 2, 1))
par(mai=c(0.6, 0.7,1, 0.6))
nber_long2<-nber_long
nber_long2[1:29]<-0

xz=seq(1,219,by=1)
xx=c(xz,rev(xz))
lowb=rep(0,219)
zz=c(lowb,rev(nber_long2))
plot(xx,zz,type='n',axes=FALSE,xlab="Horizon",ylab="",ylim=c(0,1),main="Figure S24: Recession probabilities based on capacity utilization \n (1967-2014)")
polygon(xx,zz, col="grey",border=NA,xlab="Horizon",ylab="Percent")

xx=seq(1,219,by=1)
lines(xx,c(rep(0,29),prob2),type='l', xlab="Horizon",ylab="Percent",ylim=c(0,1))

axis(1,at=c(40,60,80,100,120,140,160,180,200,220), lab=c(1970,1975,1980,1985,1990,1995,2000,2005,2010,2015))

axis(2)
box()


windows()

plot.new()
par(omi=c(0.0,0.0,0.2,0.0))
#
par(mfcol=c(2, 1))


par(mfg=c(1, 1, 2, 1))
par(mai=c(0.6, 0.7,1, 0.6))

xz=seq(1,219,by=1)
xx=c(xz,rev(xz))
lowb=rep(0,219)
zz=c(lowb,rev(nber_long))
plot(xx,zz,type='n',axes=FALSE,xlab="Horizon",ylab="",ylim=c(0,1),main="Figure S25: Recession probabilities based on unemployment \n (1960-2014)")
polygon(xx,zz, col="grey",border=NA,xlab="Horizon",ylab="")

xx=seq(1,219,by=1)
lines(xx,prob4,type='l', xlab="Horizon",ylab="Percent",ylim=c(0,1))

axis(1,at=c(0,20,40,60,80,100,120,140,160,180,200,220), lab=c(1960,1965,1970,1975,1980,1985,1990,1995,2000,2005,2010,2015))


axis(2)
box()
#title("Figure 20: Recession probabilities based on hours worked",outer=TRUE)

#---------------------------------------------------------------------

par(mfg=c(2, 1, 2, 1))
par(mai=c(0.6, 0.7,1, 0.6))

xz=seq(1,219,by=1)
xx=c(xz,rev(xz))
lowb=rep(0,219)
zz=c(lowb,rev(nber_long))
plot(xx,zz,type='n',axes=FALSE,xlab="Horizon",ylab="",ylim=c(0,1),main="Figure S26: Recession probabilities based on consumption \n (1960-2014)")
polygon(xx,zz, col="grey",border=NA,xlab="Horizon",ylab="Percent")

xx=seq(1,219,by=1)
lines(xx,prob3,type='l', xlab="Horizon",ylab="Percent",ylim=c(0,1))

axis(1,at=c(0,20,40,60,80,100,120,140,160,180,200,220), lab=c(1960,1965,1970,1975,1980,1985,1990,1995,2000,2005,2010,2015))

axis(2)
box()



