function [y,x] = RS_dgp(beta1, beta2, variance, nr, model)
    switch(model)
        case 'CG'
            sd = sqrt(variance);
            beta = [beta1 beta2];
            x = mvnrnd([1 3],[0,0.0;0.0,2],nr);
            y = x*beta'+normrnd(0,sd,nr,1);
        case 'CA'
            sd = sqrt(variance);
            x = zeros(nr,2);
            x(:,1) = 1;
            z = zeros(nr+202,1);
            for i = 3:nr+202
                z(i,1) = beta1+beta2*z(i-1,1)+normrnd(0,sd);
            end
            y = z(203:nr+202,1);
            x(:,2) = z(202:nr+201,1);
    end
end

