function [y, x] = RS_dgpA(mu0, mu1, phi, variance, p, q, nr)

    sd = sqrt(variance);
    s = zeros(nr,1);
    inds=0;
    s(1) = unifrnd(0,1)>((1-q)/(2-p-q));
    z = zeros(nr+201,1);
    z(1) = mu0+(mu1-mu0)*s(1);
    
    while inds<1e-6 %check whether regime switching has occured
        for i=2:nr+201
            if s(i-1)==0
                s(i) = (unifrnd(0,1)>p);
            else
                s(i)=(unifrnd(0,1)<q);
            end
            z(i) = mu0+(mu1-mu0)*s(i)+phi*z(i-1)+normrnd(0,sd);
        end
        y = z(202:nr+201);
        x(:,1) = ones(nr,1);
        x(:,2) = z(201:nr+200);
        inds = max(s(202:nr+201))-min(s(202:nr+201));
    end
end

%ex: [y,x,s] = RS_dgpA(-0.8, 0.8, 0.0 , 0 , 0.9, 0.9, 10)