function cv = cvcw(y,x,lp,up,nrep)
    
    nrep=max(200,nrep); 
    %at least 200 simulations
   
    %save the simulated values
  
    bcw=zeros(nrep-1,1);
    b0 = regress(y,x);
    u  = y-x*b0; 
    v0 = std(u,1);
    estc = [b0;v0];
    
    
    parfor simu=1:(nrep-1)
        [yb,xb] = bootS(y,estc);
        [~, loglik0] = lik_null(yb,xb);
        lr=zeros(16,1);
        for ct = 1:16  %optimization with different initial values
           [~, lik_a] = lik_pqcwe(yb,xb,lp,up);
           lr(ct) = 2*(lik_a-loglik0);
        end
        bcw(simu)=max(lr);
    end
    
     St=sort(bcw);
    
    %get cutoffs
    cv=[St(ceil(nrep*0.90)),St(ceil(nrep*0.925)),St(ceil(nrep*0.95)),St(ceil(nrep*0.975)),St(ceil(nrep*0.99))];
end