function [nTS1,nTS2] = funcTSm(y,xx,L,U,tol)
    nar = size(xx,2)-1;
    nn = size(xx,1);
    t  = nn+nar;
    b0 = regress(y,xx);
    u  = y-xx*b0; 
    v0 = std(u,1);

    %phi = b0(2:1+nar);
    %mu0 = b0(1);

    ltmu = u/v0^2;
    ltphi = zeros(nn,nar);
    for i=1:nar 
        ltphi(:,i) = u.*xx(:,i+1)/v0^2;
    end

    ltsig2 = (u.^2-v0^2)/(2*v0^4);

    ltmx = [ltmu,ltphi,ltsig2];

    mtmu = -1/v0^2;
    ir = 1;
    RHO_L = L*100;  %lower bound for rho
    RHO_U = U*100;  %upper bound for rho
    cv1 = zeros(length(RHO_L:RHO_U),1);
    cv2 = cv1;


    for RHO = RHO_L:RHO_U
        rho  = RHO/100;
        mu2t = zeros(nn,1);
        xs   = zeros(nn,1);

        xs(2)   = rho*ltmu(1);
        mu2t(2) = ltmu(2)*xs(2);

        for i=3:nn
            xs(i) = rho*(xs(i-1)+ltmu(i-1));
            mu2t(i) = ltmu(i)*xs(i);
        end

        mu2t = (mtmu+ltmu.^2)/2+mu2t;
        gamma_e = 1/sqrt(t)*sum(mu2t);

        b1 = regress(mu2t,ltmx);
        u1 = mu2t-ltmx*b1;
       % esqe = var(u1,1);
         esqe=mean(u1.^2);
        tspe = gamma_e/sqrt(esqe);
      %  if RHO==90
%[gamma_e,sqrt(esqe),tspe,b0(2),v0^2,RHO]
       % end
        if esqe<tol
           
            cv1(ir) = 0;
            cv2(ir) = 1;
        else 
            cv1(ir) = 0.5*(max(tspe,0))^2;
            cv2(ir) = sqrt(2*pi)*exp((tspe-1)^2/2)*normcdf(tspe-1);
        end
        ir = ir+1;  
    end

    cv1 = cv1(1:ir-1);
    cv2 = cv2(1:ir-1);
    nTS1 = max(cv1);
    nTS2 = mean(cv2);
end