function [est, loglik] = lik_cw1(y,x,p,q)

    in1 = unifrnd(-4,4);
    in2 = unifrnd(-4,4);
    in4 = unifrnd(0.1,4);
    start_point = [in1,in2,in4];
    model = @lik_model;
   
    options  =  optimset('fminsearch');
    %options  =  optimset(options , 'Algorithm ','interior-point');		
    options  =  optimset(options , 'Display'     , 'off');		
    options  =  optimset(options , 'MaxIter'     , 15000);       
    options  =  optimset(options , 'MaxFunEvals' , 3000);
    [est,nlik] = fminsearch(model, start_point,options);
    
    %lb = [-4, -4, 0.1];
    %ub = [4, 4, 4];
    %options = optimset('Display','off','Algorithm','active-set');
    %[est,nlik] = fmincon(model, start_point, [], [], [] ,[],lb, ub, [], options);
    
    
    loglik = -nlik;
    
    function nln = lik_model(pms)
        beta11 = pms(1);
        beta12 = pms(2);
        sigma2 = pms(3);
        n = length(y);
        nln = 0;
        %PRL = zeros(n,1);
        PR = zeros(n,1);
        for i=1:n
            %if i==1
                PR(i) = (1-q)/(2-p-q);
            %else
              %  PR(i) = p*PRL(i-1)+(1-q)*(1-PRL(i-1));
            %end
            %PRL(i) = (exp(-(y(i)-beta11*x(i,1))^2/(2*sigma2))*PR(i))/(exp(-(y(i)-beta11*x(i,1))^2/(2*sigma2))*PR(i)+exp(-(y(i)-beta12*x(i,1))^2/(2*sigma2))*(1-PR(i)));
            nln = nln-log(PR(i)*sigma2^(-0.5)*exp((-(y(i)-beta11*x(i,1))^2)/(2*sigma2))+(1-PR(i))*sigma2^(-0.5)*exp((-(y(i)-beta12*x(i,1))^2)/(2*sigma2)));
        end
        
    end
end