%for switching in intercept
function [est, loglik] = lik_pq1(y,x,p,q)

    in1 = unifrnd(-2,2);
    in2 = unifrnd(-2,2);
    in3 = unifrnd(-0.99,0.99);
    in4 = unifrnd(0.25,3);
    start_point = [in1,in2,in3,in4];
    model = @lik_model;
    
    lb = [-5, -5, -0.99, 0.25];
    ub = [5, 5, 0.99, 3];
    
    options = optimset('Display','off','MaxFunEvals',1e10,'Algorithm','active-set');
    [est,nlik] = fmincon(model, start_point, [], [], [] ,[],lb, ub, [], options);
    loglik = -nlik;
    
    function nln = lik_model(pms)
        beta11 = pms(1);
        beta12 = pms(2);
        beta2 = pms(3);
        sigma2 = pms(4);
        n = length(y);
        nln = 0;
        PRL = zeros(n,1);
        PR = zeros(n,1);
        for i=1:n
            if i==1
                PR(i) = (1-q)/(2-p-q);
            else
                PR(i) = p*PRL(i-1)+(1-q)*(1-PRL(i-1));
            end
            PRL(i) = (exp(-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*PR(i))/(exp(-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*PR(i)+exp(-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2/(2*sigma2))*(1-PR(i)));
            nln = nln-log(PR(i)*sigma2^(-0.5)*exp((-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2)/(2*sigma2))+(1-PR(i))*sigma2^(-0.5)*exp((-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2)/(2*sigma2)));
        end
        
    end
end