function [est, loglik] = lik_pqcwe(y,x,lp,up)

    in1 = unifrnd(-2,2);
    in2 = unifrnd(-2,2);
    in3 = unifrnd(-1,1);
    in4 = unifrnd(0.25,3);
    in5 = unifrnd(lp,up);
   
    start_point = [in1,in2,in3,in4,in5];
    model = @lik_model;
    
    lb = [-2, -2, -1, 0.25, lp];
    ub = [2,  2,  1,  3,    up];
   
    
    options  =  optimset('fmincon');
    options  =  optimset(options , 'Algorithm ','active-set');%'interior-point');
    options  =  optimset(options, 'Hessian','bfgs');
    options  =  optimset(options , 'TolFun'      , 1e-008);
    options  =  optimset(options , 'TolX'        , 1e-008);
    options  =  optimset(options , 'TolCon'      , 1e-008);
    options  =  optimset(options , 'Display'     , 'off');
    options  =  optimset(options , 'Diagnostics' , 'off');
    options  =  optimset(options , 'LargeScale'  , 'off');
    options  =  optimset(options , 'MaxIter'     , 6000);
    options  =  optimset(options , 'Jacobian'     ,'off');
    options  =  optimset(options , 'MeritFunction'     ,'multiobj');
    options  =  optimset(options , 'MaxFunEvals' , 6000);
    [est,nlik] = fmincon(model, start_point, [], [], [] ,[],lb, ub, [], options);
    loglik = -nlik;
    
    function nln = lik_model(pms)
        beta11 = pms(1);
        beta12 = pms(2);
        beta2  = pms(3);
        sigma2 = pms(4);
        p      = pms(5);
        
        n = length(y);
        nln = 0;
        PR = p;
        for i=1:n
             nln = nln-log(PR*sigma2^(-0.5)*exp((-(y(i)-beta11*x(i,1)-beta2*x(i,2))^2)/(2*sigma2))+(1-PR)*sigma2^(-0.5)*exp((-(y(i)-beta12*x(i,1)-beta2*x(i,2))^2)/(2*sigma2)));
        end
        
    end
end