function AY = re0(y,x, PQ,variance, cases)
    T = length(y);
    count = size(PQ,1);
    bHat=x\y;
    
    if cases==2 | cases==3 | cases==4
    ess  =mean((y-bHat*x).^2); %unknown variance
    elseif cases==5 | cases==6
        ess=variance; %known variance
    else
        display ('error');
    end
    
    et   = y-x*bHat;
    %calculate different derivatives of f_t'/f_t 
    sg   = 1/sqrt(ess);
    eg   = et*sg;
    d10t = sg*eg.*x;                                 %w.r.t the constant term (order (1,0))
    d20t = (sg^2)*(eg.^2-1).*(x.^2);                      %w.r.t the constant term (order (2,0))
    %d30t = (sg^3)*(eg.^3-3*eg).*(x.^3);                   %w.r.t the constant term (order (3,0))
    
    %d01t = (sg^2)*(eg.^2-1)/2;          %w.r.t the constant and variance terms (order (0,1)).
    d02t=(sg^2)*(eg.^2-1)/2;
    d04t = (sg^4)*(eg.^4-6*eg.^2+3)/4; 
    
    AY = zeros(count,1);
    for i = 1:count
        p   = PQ(i,1);
        q   = PQ(i,2);
        xi0 = (1-q)/(2-p-q); 
        %calculate the first order derivative of \xi_t (1,0) and (0,1)
        xid10t = zeros(T,1);
        
        if cases ~=4 
            for i2=2:T
            xid10t(i2) = (p+q-1)*xid10t(i2-1)+d10t(i2-1);
            end
            xid10t = xi0*(1-xi0)*(p+q-1)*xid10t;
            A = zeros(T,1);
            for i3 = 1:T
            A(i3,1) = 1*(1-xi0)/xi0*d20t(i3) ... 
                +1/(xi0^2)*(d10t(i3)*xid10t(i3)+d10t(i3)*xid10t(i3));
            end
        else
            for i2=2:T
            xid10t(i2) = (p+q-1)*xid10t(i2-1)+d02t(i2-1);
            end
            xid10t = xi0*(1-xi0)*(p+q-1)*xid10t;
            A = zeros(T,1);
            for i3 = 1:T
            A(i3,1) = 1*(1-xi0)/xi0*d04t(i3) ... 
                +1/(xi0^2)*(d02t(i3)*xid10t(i3)+d02t(i3)*xid10t(i3));
            end  
        end
        
        AY(i,:) = T^(-0.5)*sum(A);

    end
    


   
end