clear;



load('power_q0.2_c0_s_1000.mat'); %null
z0=z;
load('power_q0.2_c7.3_s_1000.mat'); %alternative

%columns of saved data: (1) CHP approximation, (2) CHP finite sample, (3)LR app, (4) LR
%sample, (5)CW app, (6) CW sample.
chpa0=z0(:,1);
chpf0=z0(:,2);
lra0=z0(:,3);
lrf0=z0(:,4);
cwa0=z0(:,5);
cwf0=z0(:,6);

%% plot cdfs; under H0
[f1,x1]=ecdf(lra0);
plot(x1,f1,'r')
hold on;
[f1,x1]=ecdf(lrf0);
plot(x1,f1,'r','LineStyle', '--')
hold on;
[f1,x1]=ecdf(chpa0);
plot(x1,f1,'b')
hold on;
[f1,x1]=ecdf(chpf0);
plot(x1,f1,'b','LineStyle', '--')
hold on;
[f1,x1]=ecdf(cwa0);
plot(x1,f1,'k')
hold on;
[f1,x1]=ecdf(cwf0);
plot(x1,f1,'k','LineStyle', '--')
hold off;


%columns of saved data: (1) CHP approximation, (2) CHP finite sample, (3)LR app, (4) LR
%sample, (5)CW app, (6) CW sample.
chpa1=z(:,1);
chpf1=z(:,2);
lra1=z(:,3);
lrf1=z(:,4);
cwa1=z(:,5);
cwf1=z(:,6);


%% plot cdfs; under H1

[f1,x1]=ecdf(lra1);
plot(x1,f1,'r')
hold on;
[f1,x1]=ecdf(lrf1);
plot(x1,f1,'r','LineStyle', '--')
hold on;
[f1,x1]=ecdf(chpa1);
plot(x1,f1,'b')
hold on;
[f1,x1]=ecdf(chpf1);
plot(x1,f1,'b','LineStyle', '--')
hold on;
[f1,x1]=ecdf(cwa1);
plot(x1,f1,'k')
hold on;
[f1,x1]=ecdf(cwf1);
plot(x1,f1,'k','LineStyle', '--')
hold off;

nrep=length(chpa0);
cv1=chpa0(nrep*0.95);
cv2=lra0(nrep*0.95);
cv3=cwa0(nrep*0.95);


rejf1=mean(chpa1>cv1);
rejf2=mean(lra1>cv2);
rejf3=mean(cwa1>cv3);


%[rejf2,rejf3,rejf1]
disp('The power gap at the 5% level');
rejf2-rejf1

