
function SupTS(nn,trm)

%% DGP and the range for p,q

b1 = 0.0; %mean
b2 = 0.5; %AR(1)coef 
s2 = 1.0; %variance of e_t

L=trm; %0.02 or 0.05;
U=1-2*trm; %0.96 or 0.90;

%% output file
myfile = ['TS_' num2str(nn) '_' num2str(trm) '.mat'];
tol=1e-5; %tol for zero
    
%nn  = 500; %sample size
%% running using 10 cores
parpool (10);
tic

ntime=50;
pTS1 = zeros(5000,6);
for task=1:100
    % dividing into smaller jobs
    ibegin = (task-1)*ntime + 1;
    iend = task*ntime;

    %nrep-1: number of simulations to produce the critical values
    nrep=200;

    parfor i=ibegin:iend
        rng(task*10000+i); 
        %set seed to ensure the same data is used
        [y,x]= RS_dgp( b1, b2, s2, nn, 'CA');
        %the first column of x is 1 
        b0 = regress(y,x);
        u  = y-x*b0; 
        v0 = std(u,1);
        est0 = [b0;v0];
        %compute the test statistic
        [test,~] = funcTSm(y,x,L,U,tol);
        %bootstrapping the critical values
        cv=cvchp(y,est0,L, U, nrep, tol);
        %save results
        pTS1(i,:)=[test,cv];
        %display results to keep track
        pTS1(i,:)  
    end
end
save(myfile,'pTS1');

rejf=zeros(5,1);
rejf(1)=sum(pTS1(:,1)>pTS1(:,2)); %10 percent
rejf(2)=sum(pTS1(:,1)>pTS1(:,3)); %7.5 percent
rejf(3)=sum(pTS1(:,1)>pTS1(:,4)); %5 percent
rejf(4)=sum(pTS1(:,1)>pTS1(:,5)); %2.5 percent
rejf(5)=sum(pTS1(:,1)>pTS1(:,6)); %1 percent

rejf'
%myfile = ['CHP_size_rejf.' num2str(task) '.mat'];
%save(myfile,'rejf');

toc
delete(gcp('nocreate')); %delete session
end


