%clear
function CHP(p,q,mu1,trm)
%% DGP and range for p,q
mu0 = -mu1;%-0.6; 
%mu1 = 0.6;
%p = 0.70;
%q = 0.90;
L=trm;%0.05;0.02;
U=1-2*trm;%0.90;0.96;
phi = 0.5;
sd  = 1; 
var=sd^2;
nn  = 500; %sample size

%% output file
myfile = ['TS_' num2str(trm) '_' num2str(p) num2str(q) num2str(mu1) '.mat'];

tol=1e-5; %tol for zero; same as in the orginal code
    
%% Running using 10 cores
parpool (10);
tic
ntime=50;
%for p=0.5 and q=0.5,the computation uses 28 cores with
%ntime=200,task=1:25.
pTS1 = zeros(5000,6);
for task=1:100
    % range of task is [1,ntasks]
    ibegin = (task-1)*ntime + 1;
    iend = task*ntime;

    %nrep-1: number of simulations to produce the critical values
    nrep=200;

    parfor i=ibegin:iend
   
        rng(task*10000+i); %set seed to run on multiple nodes
        [y,x] = RS_dgpA(mu0, mu1, phi, var, p, q, nn);
        %the first column of x is 1 
    
        b0 = regress(y,x);
        u  = y-x*b0; 
        v0 = std(u,1);
        est0 = [b0;v0];
    
        [test,~] = funcTSm(y,x,L,U,tol);
        cv=cvchp(y,est0,L, U, nrep, tol);
        pTS1(i,:)=[test,cv];
        pTS1(i,:)
   
    end
end
%myfile = ['TS_002_0709_02.' num2str(task) '.mat'];
save(myfile,'pTS1');

rejf=zeros(5,1);
%90,92.5,95,97.5,99
rejf(1)=sum(pTS1(:,1)>pTS1(:,2));
rejf(2)=sum(pTS1(:,1)>pTS1(:,3));
rejf(3)=sum(pTS1(:,1)>pTS1(:,4));
rejf(4)=sum(pTS1(:,1)>pTS1(:,5));
rejf(5)=sum(pTS1(:,1)>pTS1(:,6));

%myfile = ['CHP_power_rejf.' num2str(task) '.mat'];
%save(myfile,'rejf');

toc
    %matlabpool close
%end
delete(gcp('nocreate'));

end

